var tooltipTriggerList = [].slice.call(
  document.querySelectorAll('[data-bs-toggle="tooltip"]')
);
var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
  return new bootstrap.Tooltip(tooltipTriggerEl);
});
var baseUrl = "https://api.deproapro.com/api/";
let currentPage = 1;
let currentPageRequests = 1;
let more = false;
let moreRequests = false;
let searchCustomers = null;

chrome.storage.local.get("currentUser", function (result) {
  data = result.currentUser;
  if (data != "" && result.currentUser && result.currentUser != "") {
    currentUser = JSON.parse(result.currentUser);
    var fullname = currentUser.firstName + " " + currentUser.lastName;
    if (fullname.length > 10) {
      fullname = fullname.substring(0, 10) + "...";
    }
    document.querySelector("#username").innerHTML = fullname + "<br/>";
    onLogin();
  } else {
    onLogout();
  }
});

function onLogout() {
  chrome.storage.local.set({ currentUser: "" });
  chrome.storage.local.set({ isConnected: false });
  chrome.storage.local.set({ requestId: "" });
  chrome.storage.local.set({ customerId: "" });
  document.querySelector("#buttons").classList.add("hidden");
  document.querySelector('#navbarScrollingDropdown').classList.add("hidden");

  document.querySelector("#username").innerHTML = "";
  document.querySelector("#user").innerHTML =
    "Veuillez saisir vos identifiants ou ouvrir l'extension depuis votre compte utilisateur D2P";
  document.querySelector("#ea-form").innerHTML =
    '<div class="col-12 mb-2 login"><span class="col-12 row">Utilisateur</span><input type="text" id="ea-login" class="col-12"></div><div class="col-12 login"><span class="col-12 row" >Mot de passe</span><input type="password" id="ea-password" class="col-12"></div>  <div class="col-12 mb-3 row hidden" id="error"></div> <div class="col-12 mb-3 mt-3 text-center"><button id="connexion" class="btn btn-primary">Me connecter</button></div>' +
    '<div class="col-12 mb-3 text-center footer-text"><p class="small-text">Vous n\'êtes pas encore membre ? <a href="www.deproapro.com"><b>Inscription</b></a></p><p>Découvrez l\'extension Remplissage Semi-Automatisé D2P :<br/><br/>Remplissez automatiquement les formulaires extranets sans saisie manuelle répétitive ! 😍<br/><br/>Économisez jusqu\'à 70% du temps autre fois passé à remplir les différents champs manuellement pour obtenir vos devis. 🤩<br/><br/>Profitez d\'une précision accrue, sécurité renforcée et expérience utilisateur améliorée !!<br/><br/>Rejoignez l\'écosystème De Pro à Pro : <br/><a href="wwww.deproapro.com">wwww.deproapro.com</a></p></div>';
  // when i click on my button
  if (document.getElementById("connexion")) {
    document.getElementById("connexion").addEventListener("click", function () {
      var login = document.getElementById("ea-login").value;
      var password = document.getElementById("ea-password").value;
      fetch(`https://api.deproapro.com/api/login`, {
        method: "POST",
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json",
        },
        body: JSON.stringify({ username: login, password: password }),
      })
        .then((response) => response.json())
        .then((response) => {
          const data = response;
          if (data.hasOwnProperty("id")) {
            chrome.storage.local.set({
              currentUser: JSON.stringify(data),
            });
            currentUser = data;
            chrome.storage.local.set({ isConnected: true });
            var fullname = data.firstName + " " + data.lastName;
            if (fullname.length > 10) {
              fullname = fullname.substring(0, 10) + "...";
            }
            document.querySelector("#username").innerHTML = fullname + "<br/>";
            onLogin();
          } else {
            document.querySelector("#error").classList.remove("hidden");
            document.querySelector("#error").innerHTML =
              "L'authentification a échoué, veuillez réessayer plus tard.";
          }
        })
        .catch(function (err) {
          // There was an error
          console.log("Something went wrong.", err);
        });
    });
  }
}
function onLogin() {
  document.querySelector("#buttons").classList.remove("hidden");
  document.querySelector('#navbarScrollingDropdown').classList.remove("hidden");
  document.querySelector("#user").innerHTML = "";
  // when i click on logout
  document.querySelector("#ea-form").innerHTML =
    '<div class="col-12 d-flex p-0 align-items-center mb-3"><div class="col-6 d-flex align-items-center "><input type="text"  id="input-search" class="form-control" placeholder="Client"><a href="#" class="ms-1"><i class="fas fa-search" id="search"></i></a></div><div class="col-6 d-flex align-items-center"><input type="text"  id="input-search-request" class="form-control" placeholder="N° projet"><a href="#" class="ms-1"><i class="fas fa-search" id="search-request"></i></a></div></div><input type="hidden" id="customer"><input type="hidden" id="request"><input id="token" type="hidden" value=' +
    currentUser.token +
    ' ><div id="customer-details" class="col-12 mb-2 hidden"></div><div id="request-details" class="col-12 mb-2 hidden"></div><div id="list" class="col-12 overflow-auto "></div><div id="list-requests" class="col-12 overflow-auto "></div>';
  if (document.querySelector("#fillForm")) {
    document.getElementById("fillForm").addEventListener("click", function () {
      chrome.runtime.sendMessage({
        text: "what is my tab_id?",
        fkey: document.getElementById("request").value,
        token: document.getElementById("token").value,
      });
    });
  }
  if (document.querySelector("#search")) {
    document.getElementById("search").addEventListener("click", function () {
      currentPage = 1;
      getCustomers(currentPage, document.getElementById("input-search").value);
    });
  }
  $("#input-search").on("keyup", function (e) {
    if (e.key === "Enter" || e.keyCode === 13) {
      currentPage = 1;
      getCustomers(currentPage, $("#input-search").val());
    }
  });
  if (document.querySelector("#search-request")) {
    document
      .getElementById("search-request")
      .addEventListener("click", function () {
        document.querySelector("#request-details").classList.add("hidden");
        currentPageRequests = 1;
        getRequests(
          null,
          currentPageRequests,
          document.getElementById("input-search-request").value
        );
      });
  }
  $("#input-search-request").on("keyup", function (e) {
    if (e.key === "Enter" || e.keyCode === 13) {
      document.querySelector("#request-details").classList.add("hidden");
      currentPageRequests = 1;
      getRequests(null, currentPageRequests, $("#input-search-request").val());
    }
  });
  if (document.querySelector("#logout")) {
    document.getElementById("logout").addEventListener("click", function () {
      onLogout();
    });
  }
  if (document.querySelector("#cancel")) {
    document.getElementById("cancel").addEventListener("click", function () {
      back();
    });
  }
  if (document.querySelector("#list")) {
    document.getElementById("list").addEventListener(
      "scroll",
      () => {
        const contentContainer = document.getElementById("list");
        if (
          contentContainer.scrollHeight -
            Math.trunc(contentContainer.scrollTop) ==
            contentContainer.clientHeight &&
          more
        ) {
          currentPage++;
          getCustomers(currentPage, "");
        }
      },
      {
        passive: true,
      }
    );
  }
  if (document.querySelector("#list-requests")) {
    document.getElementById("list-requests").addEventListener(
      "scroll",
      () => {
        const contentContainer = document.getElementById("list-requests");
        const customerId = $("#customer").val();
        if (
          contentContainer.scrollHeight -
            Math.trunc(contentContainer.scrollTop) ==
            contentContainer.clientHeight &&
          moreRequests
        ) {
          currentPageRequests++;
          getRequests(customerId, currentPageRequests, "");
        }
      },
      {
        passive: true,
      }
    );
  }
}

function getCustomers(currentPage, key) {
  chrome.storage.local.set({ customerId: "" });
  document.querySelector("#spinner").classList.remove("hidden");
  fetch(baseUrl + "extension/customers?q=" + key + "&page=" + currentPage, {
    method: "GET",
    headers: {
      Authorization: "Bearer " + currentUser.token,
    },
  })
    .then((response) => response.json())
    .then((response) => {
      //register if we have more customers to show
      more = response.pagination.more;
      //init local storage
      chrome.storage.local.set({ customerId: "" });
      chrome.storage.local.set({ requestId: "" });
      chrome.storage.local.set({ searchCustomers: key });
      searchCustomers = key;
      //hidden cancel boutton
      document.querySelector("#cancel").classList.add("hidden");
      var list = document.getElementById("list");
      //show customers list
      list.classList.remove("hidden");
      //hidden submit boutton and projets list
      document.querySelector("#fillForm").classList.add("hidden");
      document.querySelector("#list-requests").classList.add("hidden");
      //init customer list if page=1
      if (currentPage == 1) list.innerHTML = "";
      //hidden customer details bloc and projet details bloc
      document.querySelector("#customer-details").classList.add("hidden");
      document.querySelector("#customer-details").innerHTML = "";
      document.querySelector("#request-details").classList.add("hidden");
      document.querySelector("#request-details").innerHTML = "";
      //create list customers
      idCustomers = [];
      if (response.results.length > 0) {
        response.results.forEach((element) => {
          email = "";
          if (element.firstEmail != null)
            email =
              "<br> Email : <a href = 'mailto: " +
              element.firstEmail +
              "'>" +
              element.firstEmail +
              "</a>";
          list.innerHTML +=
            "<div class='bloc-list mb-2 d-flex align-items-center btn' id='btn-valid-" +
            element.id +
            "'><div class='text-start col-11'>" +
            element.text +
            " " +
            element.zipCode +
            " " +
            element.city +
            "<br> Tél : " +
            element.phone +
            email +
            "</div><div class='col-1' ><a href='#'><i class='fas fa-chevron-right'></i></a></div></div>";
          idCustomers.push(element);
        });
      } else {
        if (currentPage == 1) {
          document.querySelector("#list").innerHTML =
            "<p class='text-center empty'>Aucune donnée à afficher</p>";
        }
      }
      document.querySelector("#spinner").classList.add("hidden");
      //add click event to each customer details bloc
      idCustomers.forEach((element) => {
        document
          .querySelector("#btn-valid-" + element.id)
          .addEventListener("click", function () {
            getCustomer(element.id);
            getRequests(element.id, 1, "");
          });
      });
    })
    .catch(function (err) {
      // There was an error
      console.log("Something went wrong.", err);
      document.querySelector("#spinner").classList.add("hidden");
    });
}
function getRequests(customerId, currentPage, key) {
  chrome.storage.local.set({ requestId: "" });
  document.querySelector("#spinner").classList.remove("hidden");

  fetch(
    baseUrl +
      "quote-requests-extranet?q=" +
      key +
      "&page=" +
      currentPage +
      "&customerId=" +
      customerId,
    {
      method: "GET",
      headers: {
        Authorization: "Bearer " + currentUser.token,
      },
    }
  )
    .then((response) => response.json())
    .then((response) => {
      if (currentPage == 1)
        document.querySelector("#list-requests").innerHTML = "";

      //init searchCustomers and input search project
      chrome.storage.local.set({ searchCustomers: null });
      searchCustomers == null;
      //$("#input-search-request").val("");
      //show input search project
      document.querySelector("#list-requests").classList.remove("hidden");
      document.querySelector("#cancel").classList.remove("hidden");

      idRequests = [];
      //create projects list
      if (response.results.length > 0) {
        //register if we have more projects to show
        moreRequests = response.pagination.more;
        response.results.forEach((element) => {
          idRequests.push(element.id);
          product = "";
          if (element.registration != null)
            product = "Immatriculation : " + element.registration;
          else if (element.purchaseDate != null) {
            const date = new Date(element.purchaseDate);
            let purchaseDate = date.toLocaleString("en-GB", {
              year: "numeric",
              month: "2-digit",
              day: "2-digit",
              hour: "2-digit",
              minute: "2-digit",
            });
            purchaseDate = purchaseDate.replace(
              /^(\d{2})\/(\d{2})\/(\d{4}), (\d{2}):(\d{2})/,
              "$1/$2/$3 $4:$5"
            );
            product = "Date d'achat : " + purchaseDate;
          } else if (element.firstRegistration != null) {
            const date = new Date(element.firstRegistration);
            let firstRegistration = date.toLocaleString("en-GB", {
              year: "numeric",
              month: "2-digit",
              day: "2-digit",
              hour: "2-digit",
              minute: "2-digit",
            });
            firstRegistration = firstRegistration.replace(
              /^(\d{2})\/(\d{2})\/(\d{4}), (\d{2}):(\d{2})/,
              "$1/$2/$3 $4:$5"
            );
            product =
              "Date première mise en circulation : " + firstRegistration;
          }
          const date = new Date(element.project.createdAt);
          let createdAt = date.toLocaleString("en-GB", {
            year: "numeric",
            month: "2-digit",
            day: "2-digit",
            hour: "2-digit",
            minute: "2-digit",
          });
          createdAt = createdAt.replace(
            /^(\d{2})\/(\d{2})\/(\d{4}), (\d{2}):(\d{2})/,
            "$1/$2/$3 $4:$5"
          );
          document.querySelector("#list-requests").innerHTML +=
            "<div class='bloc-list mb-2 d-flex align-items-center btn' id='btn-request-" +
            element.id +
            "'><div class='text-start col-11'> Project : " +
            element.project.id +
            " - " +
            createdAt +
            "<br>" +
            product +
            "</div><div class='col-1' ><a href='#'><i class='fas fa-chevron-right'></i></a></div></div>";
        });
        if (customerId == null) {
          document.querySelector("#customer-details").innerHTML = "";
          //create customer details bloc
          document.querySelector("#customer-details").innerHTML =
            "<div>" +
            response.results[0].customer.identity +
            "<br>" +
            response.results[0].customer.zipCode +
            " " +
            response.results[0].customer.town +
            "<br> Tél : " +
            response.results[0].customer.firstPhone +
            "<br> Email : <a href = 'mailto: " +
            response.results[0].customer.firstEmail +
            "'>" +
            response.results[0].customer.firstEmail +
            "</a></div>";
          document
            .querySelector("#customer-details")
            .classList.remove("hidden");
        }
      } else {
        if (currentPageRequests == 1) {
          document.querySelector("#list-requests").innerHTML =
            "<p class='text-center empty'>Aucune donnée à afficher</p>";
        }
      }
      document.querySelector("#list").classList.add("hidden");
      document.querySelector("#spinner").classList.add("hidden");
      //add click event to each project bloc
      idRequests.forEach((element) => {
        document
          .querySelector("#btn-request-" + element)
          .addEventListener("click", function () {
            getRequest(element);
          });
      });
    })
    .catch(function (err) {
      // There was an error
      console.log("Something went wrong.", err);
      document.querySelector("#spinner").classList.add("hidden");
    });
}
function getRequest(requestId) {
  document.querySelector("#spinner").classList.remove("hidden");
  fetch(baseUrl + "quote-request-extranet/" + requestId, {
    method: "GET",
    headers: {
      Authorization: "Bearer " + currentUser.token,
    },
  })
    .then((response) => response.json())
    .then((response) => {
      //hidden customers list
      document.getElementById("list").classList.add("hidden");
      //register request id
      $("#request").val(response.id);
      chrome.storage.local.set({ requestId: response.id });
      //show cancel boutton
      document.querySelector("#cancel").classList.remove("hidden");
      //create project details bloc
      document.querySelector("#request-details").innerHTML =
        "<div class='col-md-12 text-center reload mb-2'> <h6>Projet N° " +
        response.project.id +
        "</h6><a class='mt-2 mb-2' href='#' id='reload-" +
        response.id +
        "'> <i class='fas fa-sync-alt'></i> </a></div><div class='title'><h6>Informations souscripteur</h6></div><div id='subscriber'></div></div><div class='title'><h6>Informations véhicule</h6></div><div id='product'></div><div class='title'><h6>Informations conducteur</h6></div><div id='driver'></div><div class='title'><h6>Antécédents</h6></div><div id='antecedent'></div></div>";
      if (document.querySelector("#reload-" + response.id)) {
        document
          .querySelector("#reload-" + response.id)
          .addEventListener("click", function () {
            getRequest(response.id);
          });
      }
      if (response.subscriberTitle != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Civilité :</b> " + response.subscriberTitle + "<br>";
      if (response.subscriberFirstName != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Nom : </b> " + response.subscriberFirstName + "<br> ";
      if (response.subscriberLastName != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Prénom :</b> " + response.subscriberLastName + "<br> ";
      if (response.subscriberAddress1 != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Adresse :</b> " + response.subscriberAddress1 + "<br> ";
      if (response.subscriberPostalcode != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Code postal :</b> " + response.subscriberPostalcode + "<br> ";
      if (response.subscriberCity != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Ville :</b> " + response.subscriberCity + "<br> ";
      if (response.subscriberEmail != null)
        document.querySelector("#subscriber").innerHTML +=
          "<b>Ville :</b> " + response.subscriberEmail + "<br> ";
      switch (response.driverProfessionalCategory) {
        case 1:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Artisan <br> ";
          break;
        case 2:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Commerçant <br> ";
          break;
        case 3:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Chef d'entreprise <br> ";
          break;
        case 4:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Salarié(e)<br> ";
          break;
        case 5:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Etudiant(e) <br> ";
          break;
        case 6:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Retraité(e) <br> ";
          break;
        case 7:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Sans profession <br> ";
          break;
        case 8:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Fonctionnaire <br> ";
          break;
        case 9:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Agriculteur <br> ";
          break;
        case 10:
          document.querySelector("#subscriber").innerHTML +=
            "<b>Profession :</b> Autre <br> ";
          break;
      }
      if (response.registration != null)
        document.querySelector("#product").innerHTML +=
          "<b>Immatriculation :</b> " + response.registration + "<br> ";
      switch (response.vehicleType) {
        case 1:
          document.querySelector("#product").innerHTML +=
            "<b>Genre :</b> Automobile <br> ";
          break;
        case 2:
          document.querySelector("#product").innerHTML +=
            "<b>Genre :</b> Voiturette sans permis <br> ";
          break;
        case 3:
          document.querySelector("#product").innerHTML +=
            "<b>Genre :</b> Camping car <br> ";
          break;
      }
      if (response.firstRegistration != null) {
        const date = new Date(response.firstRegistration);
        const firstRegistration = date.toLocaleString("en-GB", {
          year: "numeric",
          month: "2-digit",
          day: "2-digit",
        });
        document.querySelector("#product").innerHTML +=
          "<b>Date première mise en circulation :</b> " +
          firstRegistration +
          "<br> ";
      }
      if (response.purchaseDate != null) {
        const date = new Date(response.purchaseDate);
        const purchaseDate = date.toLocaleString("en-GB", {
          year: "numeric",
          month: "2-digit",
          day: "2-digit",
        });
        document.querySelector("#product").innerHTML +=
          "<b>Date d'achat du véhicule :</b> " + purchaseDate + "<br> ";
      }
      switch (response.purchaseMode) {
        case 1:
          document.querySelector("#product").innerHTML +=
            "<b>Mode d'acquisition :</b> Comptant <br> ";
          break;
        case 2:
          document.querySelector("#product").innerHTML +=
            "<b>Mode d'acquisition :</b> Crédit <br> ";
          break;
        case 3:
          document.querySelector("#product").innerHTML +=
            "<b>Mode d'acquisition :</b> LOA <br> ";
          break;
        case 4:
          document.querySelector("#product").innerHTML +=
            "<b>Mode d'acquisition :</b> LLD <br> ";
          break;
        case 5:
          document.querySelector("#product").innerHTML +=
            "<b>Mode d'acquisition :</b> Prêt <br> ";
          break;
      }
      switch (response.vehiculeUsageType) {
        case 1:
          document.querySelector("#product").innerHTML +=
            "<b>Usage du véhicule :</b> Vie privée <br> ";
          break;
        case 2:
          document.querySelector("#product").innerHTML +=
            "<b>Usage du véhicule :</b> Vie privée + trajets travail <br> ";
          break;
        case 3:
          document.querySelector("#product").innerHTML +=
            "<b>Usage du véhicule :</b> Vie privée + affaires <br> ";
          break;
        case 4:
          document.querySelector("#product").innerHTML +=
            "<b>Usage du véhicule :</b> Tous déplacements <br> ";
          break;
      }
      switch (response.parkingMode) {
        case 1:
          document.querySelector("#product").innerHTML +=
            "<b>Mode de Parking :</b> Garage ou box <br> ";
          break;
        case 2:
          document.querySelector("#product").innerHTML +=
            "<b>Mode de Parking :</b> Parking collectif couvert <br> ";
          break;
        case 3:
          document.querySelector("#product").innerHTML +=
            "<b>Mode de Parking :</b> Parking collectif non couvert <br> ";
          break;
        case 4:
          document.querySelector("#product").innerHTML +=
            "<b>Mode de Parking :</b> Terrain ou cour privé <br> ";
          break;
        case 5:
          document.querySelector("#product").innerHTML +=
            "<b>Mode de Parking :</b> Voie publique <br> ";
          break;
      }
      if (response.parkingPostalcode != null)
        document.querySelector("#product").innerHTML +=
          "<b>Lieu de stationnement: </b> " +
          response.parkingPostalcode +
          "<br> ";
      switch (response.purchaseMode) {
        case 1:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Souscripteur <br> ";
          break;
        case 2:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Conducteur principal <br> ";
          break;
        case 3:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Conjoint <br> ";
          break;
        case 4:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Organisme financier <br> ";
          break;
        case 5:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Personne morale <br> ";
          break;
        case 6:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Ascendant <br> ";
          break;
        case 7:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Descendant <br> ";
          break;
        case 8:
          document.querySelector("#product").innerHTML +=
            "<b>Titulaire de la carte grise : </b> Autre, à préciser <br> ";
          break;
      }
      if (response.insuredTotalMonths) {
        document.querySelector("#product").innerHTML +=
          "<b>Nombre de mois d'assurances auto cumulés au cours des 36 derniers mois : </b> " +
          response.insuredTotalMonths +
          " <br> ";
      }
      switch (response.usualDriverType) {
        case 1:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Souscripteur <br> ";
          break;

        case 2:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Conjoint/concubin <br> ";
          break;
        case 3:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Ascendant <br> ";
          break;
        case 4:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Descendant <br> ";
          break;
        case 5:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Sans lien <br> ";
          break;
        case 6:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Non désigné <br> ";
          break;
        case 7:
          document.querySelector("#driver").innerHTML +=
            "<b>Conducteur habituel : </b> Autre <br> ";
          break;
      }
      if (response.driverTitle != null)
        document.querySelector("#driver").innerHTML +=
          "<b>Civilité :</b> " + response.driverTitle + "<br>";
      if (response.driverLastName != null)
        document.querySelector("#driver").innerHTML +=
          "<b>Nom :</b> " + response.driverLastName + "<br>";
      if (response.driverFirstName != null)
        document.querySelector("#driver").innerHTML +=
          "<b>Prénom :</b> " + response.driverFirstName + "<br>";
      switch (response.driverMaritalStatus) {
        case 1:
          document.querySelector("#driver").innerHTML +=
            "<b>Situation de Famille :</b> Célibataire <br>";
          break;
        case 2:
          document.querySelector("#driver").innerHTML +=
            "<b>Situation de Famille :</b> Marié(e) <br>";
          break;
        case 3:
          document.querySelector("#driver").innerHTML +=
            "<b>Situation de Famille :</b> Pacsé <br>";
          break;
        case 4:
          document.querySelector("#driver").innerHTML +=
            "<b>Situation de Famille :</b> Veuf(ve) <br>";
          break;
        case 5:
          document.querySelector("#driver").innerHTML +=
            "<b>Situation de Famille :</b> Autre <br>";
          break;
      }
      if (response.driverBirthDate != null) {
        const date = new Date(response.driverBirthDate);
        const driverBirthDate = date.toLocaleString("en-GB", {
          year: "numeric",
          month: "2-digit",
          day: "2-digit",
        });
        document.querySelector("#driver").innerHTML +=
          "<b>Date de Naissance :</b> " + driverBirthDate + "<br>";
      }
      if (response.driverLicenceDate != null) {
        const date = new Date(response.driverLicenceDate);
        const driverLicenceDate = date.toLocaleString("en-GB", {
          year: "numeric",
          month: "2-digit",
          day: "2-digit",
        });
        document.querySelector("#driver").innerHTML +=
          "<b>Date d'obtention du permis :</b> " + driverLicenceDate + "<br>";
      }
      if (response.damageCount != null)
        document.querySelector("#antecedent").innerHTML +=
          "<b>Nombre de sinistres :</b> " + response.damageCount + "<br>";
      document.getElementById("fillForm").classList.remove("hidden");
      document.querySelector("#request-details").classList.remove("hidden");
      document.querySelector("#spinner").classList.add("hidden");
      document.querySelector("#list-requests").classList.add("hidden");
    })
    .catch(function (err) {
      // There was an error
      console.log("Something went wrong.", err);
      document.querySelector("#spinner").classList.add("hidden");
    });
}
function getCustomer(customerId) {
  document.querySelector("#spinner").classList.remove("hidden");
  fetch(baseUrl + "customers/" + customerId, {
    method: "GET",
    headers: {
      Authorization: "Bearer " + currentUser.token,
    },
  })
    .then((response) => response.json())
    .then((response) => {
      //update customerId value
      $("#customer").val(customerId);
      chrome.storage.local.set({ customerId: customerId });
      //create customer details bloc
      document.querySelector("#customer-details").innerHTML =
        "<div>" +
        response.identity +
        "<br>" +
        response.zipCode +
        " " +
        response.town +
        "<br> Tél : " +
        response.firstPhone +
        "<br> Email : <a href = 'mailto: " +
        response.firstEmail +
        "'>" +
        response.firstEmail +
        "</a></div>";
      document.querySelector("#customer-details").classList.remove("hidden");
    })
    .catch(function (err) {
      // There was an error
      console.log("Something went wrong.", err);
      document.querySelector("#spinner").classList.add("hidden");
    });
}
function back() {
  //back to projects list
  if ($("#request").val() != "") {
    chrome.storage.local.set({ requestId: "" });
    document.querySelector("#request-details").classList.add("hidden");
    document.querySelector("#request-details").innerHTML = "";
    $("#request").val("");
    getRequests($("#customer").val(), currentPageRequests, "");
  }
  //back to customers list
  else if ($("#customer").val() != "" && $("#request").val() == "") {
    $("#input-search").val(searchCustomers);
    getCustomers(currentPage, searchCustomers);
    chrome.storage.local.set({ customerId: "" });
    chrome.storage.local.set({ requestId: "" });
    var listRequests = document.getElementById("list-requests");
    listRequests.innerHTML = "";
    $("#customer").val("");
    $("#request").val("");
    document.querySelector("#customer-details").innerHTML = "";
    document.querySelector("#request-details").classList.add("hidden");
    document.querySelector("#request-details").innerHTML = "";
  }
}
//show data from local storage
chrome.storage.local.get(
  ["customerId", "requestId", "searchCustomers"],
  function (result) {
    if (result.searchCustomers && result.searchCustomers != null) {
      searchCustomers = result.searchCustomers;
      getCustomers(currentPage, result.searchCustomers);
      $("#input-search").val(result.searchCustomers);
    } else if (result.customerId || result.requestId) {
      getCustomer(result.customerId);
      $("#customer").val(result.customerId);
      if (result.requestId == "") getRequests(result.customerId, 1, "");
      else {
        $("#request").val(result.requestId);
        getRequest(result.requestId);
      }
    }
  }
);
// Listen for storage events using chrome.storage.local API
chrome.storage.local.onChanged.addListener(async function (changes, namespace) {
  for (key in changes) {
    // Check if the changed key is "currentUser"
    if (key === "currentUser") {
      chrome.storage.local.get("currentUser", async function (result) {
        const storage = result;
        if (storage.currentUser) {
          currentUser = JSON.parse(storage.currentUser);
          var fullname = currentUser.firstName + " " + currentUser.lastName;
          if (fullname.length > 10) {
            fullname = fullname.substring(0, 10) + "...";
          }
          document.querySelector("#username").innerHTML = fullname + "<br/>";
          onLogin();
        } else {
          onLogout();
        }
      });
    }
  }
});
