// Allows users to open the side panel by clicking on the action toolbar icon
chrome.sidePanel
  .setPanelBehavior({ openPanelOnActionClick: true })
  .catch((error) => console.error(error));
const baseUrl = "https://api.deproapro.com/";
const s3Url = "https://entreagents.s3.eu-west-3.amazonaws.com/";

var code = "";
const iframeData = {};

// Listen for onUpdated event
chrome.tabs.onUpdated.addListener(async function (tabId, changeInfo, tab) {
  if (changeInfo.status == "complete") {
    // check if the page refresh has completed
    if (tab.url.includes("entreagents.com")) {
      chrome.cookies.set({
        url: tab.url,
        name: "isInstalled",
        value: "true",
        secure: false,
        httpOnly: false,
        expirationDate: Date.now() + 24 * 60 * 60 * 1000, // Cookie expiration (1 day from now)
      });

      const fromPageLocalStore = await chrome.scripting.executeScript({
        target: { tabId: tabId },
        func: getLocalStorage,
      });
      const storage = JSON.parse(fromPageLocalStore[0].result);
      if (storage.currentUser && storage.currentUser != "") {
        chrome.storage.local.get("isConnected", function (flag) {
          if (
            (flag.isConnected && flag.isConnected == false) ||
            !flag.isConnected
          ) {
            chrome.storage.local.set({ currentUser: storage.currentUser });
          }
        });
      } else {
        chrome.storage.local.get("isConnected", function (flag) {
          if (
            (flag.isConnected && flag.isConnected == false) ||
            !flag.isConnected
          ) {
            chrome.storage.local.set({ currentUser: "" });
          }
        });
      }
    }
  }
  await chrome.sidePanel.setOptions({
    tabId,
    path: "sidepanel.html",
    enabled: true,
  });
});

function getExtranet() {
  return fetch(baseUrl + "api/extranet", {}).then((response) =>
    response
      .json()
      .then((data) => ({
        data: data,
      }))
      .then((res) => {
        const listExtranet = res.data.map(function (extranet) {
          return JSON.parse(extranet);
        });
        return listExtranet;
      })
  );
}

function getLocalStorage() {
  return JSON.stringify(localStorage);
}
async function execInPage(code) {
  const [tab] = await chrome.tabs.query({ currentWindow: true, active: true });
  if (
    tab.url.includes("https://www.april-on.fr/") ||
    tab.url.includes("https://www.sollyazarpro.com/") ||
    tab.url.includes("https://www.luxior.fr/")
  ) {
    var res = await chrome.webNavigation.getAllFrames({ tabId: tab.id });
    var frames = [];
    if (tab.url.includes("https://www.april-on.fr/")) {
      for (let idx = 0; idx < res.length; idx++) {
        if (
          res[idx].url.includes("https://auto.april-on.fr/") &&
          res[idx].frameId != 0
        ) {
          frames.push(res[idx].frameId);
        }
      }
    }
    if (tab.url.includes("https://www.sollyazarpro.com/")) {
      for (let idx = 0; idx < res.length; idx++) {
        if (
          (res[idx].url.includes("https://auto.sollyazarpro.com/") ||
            res[idx].url.includes("https://opendrive.sollyazarpro.com/") ||
            res[idx].url.includes("https://tpv.sollyazarpro.com/")) &&
          res[idx].frameId != 0
        ) {
          if (res[idx].url.includes("https://opendrive.sollyazarpro.com/"))
            code = "var useSelect2=false ; " + code;
          else code = "var useSelect2=true ; " + code;
          frames.push(res[idx].frameId);
        }
      }
    }
    if (tab.url.includes("https://www.luxior.fr/")) {
      for (let idx = 0; idx < res.length; idx++) {
        if (
          res[idx].url.includes(
            "https://www.luxior.fr/e-Select_IS/Pages/Automobile/FEN_AUTO_SAISIE_DEVIS.aspx"
          ) &&
          res[idx].frameId != 0
        ) {
          frames.push(res[idx].frameId);
        }
      }
    }
    chrome.scripting.executeScript({
      target: { tabId: tab.id, frameIds: frames },
      func: (code) => {
        const el = document.createElement("script");
        el.textContent = code;
        document.body.appendChild(el);
        el.remove();
      },
      args: [code],
      world: "MAIN",
    });
  } else {
    chrome.scripting.executeScript({
      target: { tabId: tab.id },
      func: (code) => {
        const el = document.createElement("script");
        el.textContent = code;
        document.body.appendChild(el);
        el.remove();
      },
      args: [code],
      world: "MAIN",
    });
  }
}

chrome.runtime.onMessage.addListener(async (msg, sender, sendResponse) => {
  getExtranet().then(async (data) => {
    const listExtranet = data.map(function (extranet) {
      return extranet;
    });
    if ((msg.text = "what is my tab_id?")) {
      const [tab] = await chrome.tabs.query({
        currentWindow: true,
        active: true,
      });

      const inTabs = listExtranet.some(function (extranet) {
        return tab.url.includes(extranet.url);
      });
      if (inTabs) {
        var res = await chrome.webNavigation.getAllFrames({
          tabId: tab.id,
        });
        var frames = [];
        if (tab.url.includes("https://www.luxior.fr/default.aspx")) {
          for (let idx = 0; idx < res.length; idx++) {
            if (
              res[idx].url.includes("https://www.luxior.fr/Frm_Droite.aspx") ||
              (res[idx].url.includes(
                "https://www.luxior.fr/e-Select_IS/Pages/Automobile/FEN_AUTO_SAISIE_DEVIS.aspx"
              ) &&
                res[idx].frameId != 0)
            ) {
              frames.push(res[idx].frameId);
            }
          }
          chrome.scripting.executeScript(
            {
              target: {
                tabId: tab.id,
                frameIds: frames,
              },
              func: (vars) => Object.assign(self, vars),
            },
            async () => {
              const extranet = listExtranet.filter((extranet) =>
                tab.url.includes(extranet.url)
              );
              const url = s3Url + "chrome-extension/" + extranet[0].autoFile;
              fetch(url)
                .then((response) => response.text())
                .then(async (txt) => {
                  const inTabs = listExtranet.some(function (extranet) {
                    return tab.url.includes(extranet.url);
                  });
                  if (inTabs) {
                    execInPage(
                      "var fkey=" +
                        msg.fkey +
                        "; " +
                        "var token='" +
                        msg.token +
                        "' ; " +
                        txt
                    );
                  }
                });
            }
          );
        } else {
          chrome.scripting.executeScript(
            {
              target: {
                tabId: tab.id,
              },
              func: (vars) => Object.assign(self, vars),
            },
            async () => {
              const extranet = listExtranet.filter((extranet) =>
                tab.url.includes(extranet.url)
              );
              const url = s3Url + "chrome-extension/" + extranet[0].autoFile;
              fetch(url)
                .then((response) => response.text())
                .then(async (txt) => {
                  execInPage(
                    "var fkey=" +
                      msg.fkey +
                      "; " +
                      "var token='" +
                      msg.token +
                      "' ; " +
                      txt
                  );
                });
            }
          );
        }
      }
    }
  });
});
